package nl.jointeffort;

import java.util.Iterator;

import javax.inject.Inject;
import javax.persistence.EntityManager;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.data.DataView;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import nl.jointeffort.wicket.EntityProvider;

public class HomePage extends WebPage {
    private static final long serialVersionUID = 1L;

    public HomePage(final PageParameters parameters) {
        add(new DataView("employees", new EmployeeProvider()) {
            @Override
            protected void populateItem(Item item) {
                IModel user = item.getModel();
                item.add(new Label("first", new PropertyModel(user, "firstName")));
                item.add(new Label("last", new PropertyModel(user, "lastName")));
                item.add(new Label("email", new PropertyModel(user, "email")));
            }
        });
    }

    private static class EmployeeProvider extends EntityProvider {
        @Inject
        EntityManager em;

        public Iterator iterator(int first, int count) {
            return em.createQuery("FROM Employee").setFirstResult(first).setMaxResults(count).getResultList()
                .iterator();
        }

        public int size() {
            Long count = (Long) em.createQuery("SELECT COUNT(*) FROM Employee").getSingleResult();
            return count.intValue();
        }
    }
}
