package nl.jointeffort.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.apache.commons.codec.digest.DigestUtils;
import org.apache.commons.lang.StringUtils;

@Entity
@Table(name = "users")
public class User extends AbstractBaseEntity {

    private String username;

    private String roles;

    private String email;

    @Column(length = 512)
    private String passwordHash;

    public void setPassword(String plainPass) {
        if (StringUtils.isNotBlank(plainPass)) {
            passwordHash = DigestUtils.sha512Hex(plainPass);
        }
    }

    public boolean hasPassword(String plainPass) {
        return StringUtils.isNotBlank(plainPass) && passwordHash.equals(DigestUtils.sha512(plainPass));
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getRoles() {
        return roles;
    }
}
