package nl.jointeffort.wicket;

import javax.inject.Inject;
import javax.persistence.EntityManager;

import org.apache.wicket.model.IModel;

import net.ftlines.wicket.cdi.CdiContainer;

public class EntityModel<T> implements IModel<T> {

    private static final long serialVersionUID = 1L;

    @Inject
    private EntityManager em;

    private Object id;
    private Class<?> type;

    private transient T entity;

    public EntityModel(T entity) {
        CdiContainer.get().getNonContextualManager().inject(this);
        setObject(entity);
    }

    public T getObject() {
        if (entity == null) {
            entity = (T) em.find(type, id);
        }
        return entity;
    }

    public final void setObject(T other) {
        type = other.getClass();
        id = em.getEntityManagerFactory().getPersistenceUnitUtil().getIdentifier(other);
        entity = other;
    }

    public void detach() {
        entity = null;
    }

}
