package nl.jointeffort.jpa.bootstrap;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;

import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.csv.CsvDataSet;
import org.dbunit.ext.h2.H2Connection;
import org.dbunit.operation.DatabaseOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DemoDataLoader {

    private static final Logger LOG = LoggerFactory.getLogger(DemoDataLoader.class);

    private static final String DB_USER = "sa";
    private static final String DB_PASS = "";
    private static final String DB_URL = "jdbc:h2:mem:cdidemo";
    private static final String DB_SCHEMA = null;

    private static IDatabaseConnection openConnection(String url, String schema, String user, String password) {
        try {
            Connection jdbcConnection = DriverManager.getConnection(url, user, password);
            return new H2Connection(jdbcConnection, schema);
        } catch (Exception e) {
            LOG.error("Could not get a connection with " + url, e);
        }
        return null;
    }

    public static void loadDemoData(File importLocation) {
        IDatabaseConnection connection = openConnection(DB_URL, DB_SCHEMA, DB_USER, DB_PASS);
        if (connection != null) {
            try {
                IDataSet dataSet = new CsvDataSet(importLocation);
                DatabaseOperation.CLEAN_INSERT.execute(connection, dataSet);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
